unit Unit1;

{ integer cube root }

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TForm1 = class(TForm)
    numberEdit: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    rootlabel: TStaticText;
    remainderlabel: TStaticText;
    Label3: TLabel;
    GoBtn: TButton;
    procedure GoBtnClick(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

const alpha = ['a'..'z'];//dummy: prevent illegal virus warning in zipped mode

function CubeRoot(N : longInt; var rem : longInt) : smallInt;
//  -1,073,741,823 <= N <= 1,073,741,823
//return integer cube root of N and remainder rem
const max = 1073741824;
var NX,sub,r2 : longInt;
    root : word;
    p : shortInt;
    neg : boolean;
begin
 if (N <= -max) or (N >= max) then
  begin
   result := 0;
   rem := N;
   exit;
  end;
 if N < 0 then begin
                N := -N;
                neg := true;
               end else neg := false;
 p := 30;
 root := 0;
 repeat
  r2 := root shl 1;
  sub := r2*(r2+1)*3+1;
  sub := sub shl p;
  root := root shl 1;
  NX := N - sub;
  if NX >= 0 then
   begin
    N := NX;
    root := root or 1;
   end;
  p := p - 3;
 until p < 0;
 if neg then begin
              root := -root;
              N := -N;
             end;
 result := root;
 rem := N;
end;

procedure TForm1.GoBtnClick(Sender: TObject);
var N,rem : longInt;
    root  : smallInt;
begin
 if length(numberEdit.Text) = 0 then numberEdit.Text := '0';
 N := strtoInt(numberEdit.Text);
 root := cubeRoot(N,rem);
 rootLabel.Caption := inttostr(root);
 remainderlabel.Caption := inttostr(rem);
end;

procedure TForm1.FormKeyPress(Sender: TObject; var Key: Char);
var OK,mt : boolean;
begin
 OK := false;
 with numberEdit do
  begin
   mt := length(text) = 0;
   case key of
    #8       : OK := true;
    '1'..'9' : OK := true;
    '0'      : OK := not(mt);
    '$'      : OK := mt;
    'a'..'f' : OK := text[1] = '$';
    '-'      : OK := mt;
   end;
   if OK = false then key := #0;
  end;
end;

end.
 